#> end_cit:buildings/stack/generate
# `(x_offset, y_offset, z_offset, Name, Angle, Rotation)`
#
# Runs an area check, and then places the given structure, and runs any
# configured stacking and post-processing procedures
#
# Returns: -1 if the area check failed, 0 if structure placement failed, 1 
# otherwise

# Area check - fail means reduce a size
$execute unless blocks ^-$(x_offset) ^ ^-$(z_offset) ^$(x_offset) ^ ^$(z_offset) ~-$(x_offset) 255 ~-$(z_offset) all run return -1

$execute store result score $generated end_cit.data rotated $(Angle) 0 run place template $(Name) ^$(x_offset) ^$(y_offset) ^-$(z_offset) $(Rotation)
execute if score $generated end_cit.data matches 0 run return 0

execute if data storage end_cit:structure PostProcessors run function end_cit:buildings/post_process with storage end_cit:structure structure
function end_cit:buildings/stack/generate_stack with storage end_cit:structure structure

return 1