#> end_cit:roads/select
# `(width, check_dist)`
#
# Uses the check distance to determine which sides of the tiles need roads 
# linked to them, and randomises tiles which have neither road nor terrain.
#
# Reads the `$override_sides` scoreboard flag in `end_cit.data` to force the 
# side count to whatever it is set to at the time of function call
#
# Creates new markers to place further tiles in the following ticks

# Reset scores
execute unless score $override_sides end_cit.data matches 1 run scoreboard players set sides end_cit.data 0

# Check sides
$execute unless score $override_sides end_cit.data matches 1 positioned ~ ~-1 ~-$(check_dist) if predicate end_cit:technical/road_block run scoreboard players operation sides end_cit.data += #north end_cit.data
$execute unless score $override_sides end_cit.data matches 1 positioned ~ ~-1 ~-$(check_dist) if predicate end_cit:technical/air_block if function end_cit:roads/randomise_side run scoreboard players operation sides end_cit.data += #north end_cit.data
$execute unless score $override_sides end_cit.data matches 1 positioned ~ ~-1 ~$(check_dist) if predicate end_cit:technical/road_block run scoreboard players operation sides end_cit.data += #south end_cit.data
$execute unless score $override_sides end_cit.data matches 1 positioned ~ ~-1 ~$(check_dist) if predicate end_cit:technical/air_block if function end_cit:roads/randomise_side run scoreboard players operation sides end_cit.data += #south end_cit.data

$execute unless score $override_sides end_cit.data matches 1 positioned ~$(check_dist) ~-1 ~ if predicate end_cit:technical/road_block run scoreboard players operation sides end_cit.data += #east end_cit.data
$execute unless score $override_sides end_cit.data matches 1 positioned ~$(check_dist) ~-1 ~ if predicate end_cit:technical/air_block if function end_cit:roads/randomise_side run scoreboard players operation sides end_cit.data += #east end_cit.data

$execute unless score $override_sides end_cit.data matches 1 positioned ~-$(check_dist) ~-1 ~ if predicate end_cit:technical/road_block run scoreboard players operation sides end_cit.data += #west end_cit.data
$execute unless score $override_sides end_cit.data matches 1 positioned ~-$(check_dist) ~-1 ~ if predicate end_cit:technical/air_block if function end_cit:roads/randomise_side run scoreboard players operation sides end_cit.data += #west end_cit.data


# Reduce dead-ending
$execute if score sides end_cit.data matches 1 positioned ~ ~-1 ~$(check_dist) if predicate end_cit:technical/air_block run scoreboard players operation sides end_cit.data += #south end_cit.data
$execute if score sides end_cit.data matches 4 positioned ~ ~-1 ~-$(check_dist) if predicate end_cit:technical/air_block run scoreboard players operation sides end_cit.data += #north end_cit.data
$execute if score sides end_cit.data matches 2 positioned ~-$(check_dist) ~-1 ~ if predicate end_cit:technical/air_block run scoreboard players operation sides end_cit.data += #west end_cit.data
$execute if score sides end_cit.data matches 8 positioned ~$(check_dist) ~-1 ~ if predicate end_cit:technical/air_block run scoreboard players operation sides end_cit.data += #east end_cit.data

execute store result storage end_cit:data sides int 1 run scoreboard players get sides end_cit.data

function end_cit:roads/pregen_tile with storage end_cit:data

$execute if block ~-$(check_dist) ~-1 ~ minecraft:air run summon minecraft:marker ~-$(width) ~ ~ {Tags:["city_generator"]}
$execute if block ~$(check_dist) ~-1 ~ minecraft:air run summon minecraft:marker ~$(width) ~ ~ {Tags:["city_generator"]}
$execute if block ~ ~-1 ~$(check_dist) minecraft:air run summon minecraft:marker ~ ~ ~$(width) {Tags:["city_generator"]}
$execute if block ~ ~-1 ~-$(check_dist) minecraft:air run summon minecraft:marker ~ ~ ~-$(width) {Tags:["city_generator"]}

kill @s[tag=city_generator]
scoreboard players set $override_sides end_cit.data 0